-- name: [CS] Vault-Boy
-- description: by 6b

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/blob/main/API-doc.md

    Use this if you're curious on how anything here works >v<
]]

local E_MODEL_VB = smlua_model_util_get_id("vb_geo")
local E_MODEL_VBO = smlua_model_util_get_id("vbo_geo")
local E_MODEL_VBCC = smlua_model_util_get_id("vbcc_geo")
local E_MODEL_VBOCC = smlua_model_util_get_id("vbocc_geo")

local TEX_VB_ICON = get_texture_info("vault-boy")

local TEXT_MOD_NAME = "[CS] Vault-Boy"

local VOICETABLE_VB = {
    [CHAR_SOUND_ATTACKED] = 'goofy1.mp3',
    [CHAR_SOUND_DOH] = 'ground.mp3',
    [CHAR_SOUND_DROWNING] = {'cold.mp3', 'ahh.mp3'},
    [CHAR_SOUND_DYING] = {'cold.mp3', 'ahh.mp3'},
    [CHAR_SOUND_GROUND_POUND_WAH] = 'ground.mp3',
    [CHAR_SOUND_HAHA] = 'hi.mp3',
    [CHAR_SOUND_HAHA_2] = 'hi.mp3',
    [CHAR_SOUND_HERE_WE_GO] = 'woheh.mp3',
    [CHAR_SOUND_HOOHOO] = 'jump4.mp3',
    [CHAR_SOUND_MAMA_MIA] = {'cry.mp3', 'gibberish.mp3'},
    [CHAR_SOUND_OKEY_DOKEY] = 'woheh.mp3',
    [CHAR_SOUND_ON_FIRE] = 'wohaaaoh.mp3',
    [CHAR_SOUND_OOOF] = 'uhh.mp3',
    [CHAR_SOUND_OOOF2] = 'uhh.mp3',
    [CHAR_SOUND_PUNCH_HOO] = 'jump2.mp3',
    [CHAR_SOUND_PUNCH_WAH] = {'jump1.mp3', 'jump5.mp3', 'jump3.mp3'},
    [CHAR_SOUND_PUNCH_YAH] = {'jump1.mp3', 'jump5.mp3', 'jump3.mp3'},
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'oui.mp3',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'woheh.mp3',
    [CHAR_SOUND_WAAAOOOW] = 'wohaaaoh.mp3',
    [CHAR_SOUND_WAH2] = 'rien.ogg',
    [CHAR_SOUND_WHOA] = 'ground.mp3',
    [CHAR_SOUND_YAHOO] = {'woheh.mp3', 'oui.mp3'},
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'woheh.mp3', 'oui.mp3'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'jump1.mp3', 'jump5.mp3', 'jump3.mp3'},
    [CHAR_SOUND_YAWNING] = 'rien.ogg',
    [CHAR_SOUND_HRMM] = 'rien.ogg',
    [CHAR_SOUND_UH2_2] = 'rien.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'cold.mp3',
    [CHAR_SOUND_PANTING] = 'rien.ogg',
    [CHAR_SOUND_LETS_A_GO] = {'woheh.mp3', 'oui.mp3'},
    [CHAR_SOUND_UH] = 'rien.ogg',
    [CHAR_SOUND_UH2] = 'rien.ogg',
}


if _G.charSelectExists then
    CT_CHAR = _G.charSelect.character_add("Vault-Boy", {"Optimism amidst the post-apocalyptic chaos of Fallout!", "Always smiling, always ready to tackle challenges"}, "6b", {r = 93, g = 173, b = 226}, E_MODEL_VB, CT_MARIO, TEX_VB_ICON)
    CT_CHAR = _G.charSelect.character_add("Vault-Boy (Outlines)", {"Optimism amidst the post-apocalyptic chaos of Fallout!", "Always smiling, always ready to tackle challenges"}, "6b", {r = 93, g = 173, b = 226}, E_MODEL_VBO, CT_MARIO, TEX_VB_ICON)
    CT_CHAR = _G.charSelect.character_add("Vault-Boy (CC)", {"Optimism amidst the post-apocalyptic chaos of Fallout!", "Always smiling, always ready to tackle challenges"}, "6b", {r = 93, g = 173, b = 226}, E_MODEL_VBCC, CT_MARIO, TEX_VB_ICON)
    CT_CHAR = _G.charSelect.character_add("Vault-Boy (CC + Outlines)", {"Optimism amidst the post-apocalyptic chaos of Fallout!", "Always smiling, always ready to tackle challenges"}, "6b", {r = 93, g = 173, b = 226}, E_MODEL_VBOCC, CT_MARIO, TEX_VB_ICON)

    -- the following must be hooked for each character added
    _G.charSelect.character_add_voice(E_MODEL_VB, VOICETABLE_VB)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_VB then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_VB then return _G.charSelect.voice.snore(m) end
    end)

        -- the following must be hooked for each character added
        _G.charSelect.character_add_voice(E_MODEL_VBO, VOICETABLE_VB)
        hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
            if _G.charSelect.character_get_voice(m) == VOICETABLE_VB then return _G.charSelect.voice.sound(m, sound) end
        end)
        hook_event(HOOK_MARIO_UPDATE, function (m)
            if _G.charSelect.character_get_voice(m) == VOICETABLE_VB then return _G.charSelect.voice.snore(m) end
        end)

                -- the following must be hooked for each character added
        _G.charSelect.character_add_voice(E_MODEL_VBCC, VOICETABLE_VB)
        hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
            if _G.charSelect.character_get_voice(m) == VOICETABLE_VB then return _G.charSelect.voice.sound(m, sound) end
        end)
        hook_event(HOOK_MARIO_UPDATE, function (m)
            if _G.charSelect.character_get_voice(m) == VOICETABLE_VB then return _G.charSelect.voice.snore(m) end
        end)

                        -- the following must be hooked for each character added
        _G.charSelect.character_add_voice(E_MODEL_VBOCC, VOICETABLE_VB)
        hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
            if _G.charSelect.character_get_voice(m) == VOICETABLE_VB then return _G.charSelect.voice.sound(m, sound) end
        end)
        hook_event(HOOK_MARIO_UPDATE, function (m)
            if _G.charSelect.character_get_voice(m) == VOICETABLE_VB then return _G.charSelect.voice.snore(m) end
        end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end